<?
function XLSFile($query, $file) 
{ 
    /******************************************************* 
     
    FUNCTION NAME: 
    XLSFile 
     
    AUTHOR: 
    bokeh 
     
    PURPOSE: 
    To create an Excel (.XLS) format file from any valid 
    database query. 
     
    DESCRIPTION: 
    bool XLSFile( string query, string file ) 
     
    INPUTS: 
    $query (string) should be a valid MySQL query. 
    $file (string) is the file (including the path)to 
    which the Excel formatted data should be saved. A 
    database connection must exist before calling this 
    function. 
     
    RETURN VALUE: 
    Boolean, true on success, false otherwise. 
     
    *********************************************************/ 
	$db = new SQLite3('master.db');
    $result = $db->query($query);
	
    if(true) 
    { 
        $fh = @fopen($file, 'w+') or 
            trigger_error('Function <b>RealXLSFile</b>: file could not be created (permissions problem).', E_USER_ERROR);         
        fwrite($fh, pack("ssssss", 0x809, 0x8, 0x0, 0x10, 0x0, 0x0)); 
        $first_time = true; 
        $XLSrow = 0; $XLScol = 0; 
        while($row = $result->fetchArray(SQLITE3_ASSOC)) 
        { 
            if($first_time) 
            { 
                $first_time = false; 
                $headings = array_keys($row); 
                foreach($headings as $heading) 
                { 
                    fwrite($fh, pack("ssssss", 0x204, 8+($L = strlen($heading)), $XLSrow, $XLScol++, 0x0, $L).$heading); 
                } 
            } 
            $XLScol=0; ++$XLSrow; 
            foreach($headings as $heading) 
            { 
                if(is_numeric($row[$heading])) 
                { 
                    fwrite($fh, pack("sssss", 0x203, 14, $XLSrow, $XLScol++, 0x0).pack("d", $row[$heading])); 
                } 
                else 
                { 
                    fwrite($fh, pack("ssssss", 0x204, 8 + ($L = strlen($row[$heading])), $XLSrow, $XLScol++, 0x0, $L).$row[$heading]); 
                } 
            } 
        } 
        fwrite($fh, pack("ss", 0x0A, 0x00)); 
        fclose($fh); 
        return true; 
    } 
    return false; 
} 

function XLSOutput($query, $filename = null) 
{ 
    /******************************************************* 
     
    FUNCTION NAME: 
    XLSOutput 
     
    AUTHOR: 
    bokeh 
     
    PURPOSE: 
    To send Excel (.XLS) format output (and headers) to the 
    client for any valid database query. 
     
    DESCRIPTION: 
    bool XLSOutput( string query [, string filename ] ) 
     
    INPUTS: 
    $query (string) should be a valid MySQL query. A database 
    connection must exist before calling this function. 
    $filename (optional), filename that will be sent to the 
    client along with the corresponding output. 
     
    RETURN VALUE: 
    on success: null + headers and echoed output, 
    on failure: false 
     
    *********************************************************/ 
	$db = new SQLite3('/var/log/asterisk/master.db');
    $result = $db->query($query);
	
    if(true) 
    { 
        header('Content-Type: application/vnd.ms-excel'); 
        if(!empty($filename)) 
        { 
            header('Content-Disposition: attachment; filename="'.$filename.'"'); 
        } 
        echo pack("ssssss", 0x809, 0x8, 0x0, 0x10, 0x0, 0x0); 
        $first_time = true; 
        $XLSrow = 0; $XLScol = 0; 
        while($row = $result->fetchArray(SQLITE3_ASSOC)) 
        { 
            if($first_time) 
            { 
                $first_time = false;
                $headings = array_keys($row);
                foreach($headings as $heading) 
                { 
                    echo pack("ssssss", 0x204, 8+($L = strlen($heading)), $XLSrow, $XLScol++, 0x0, $L).$heading; 
                } 
            } 
            $XLScol=0; ++$XLSrow; 
            foreach($headings as $heading) 
            { 
                if(is_numeric($row[$heading])) 
                { 
                    echo pack("sssss", 0x203, 14, $XLSrow, $XLScol++, 0x0).pack("d", $row[$heading]); 
                } 
                else 
                { 
                    echo pack("ssssss", 0x204, 8 + ($L = strlen($row[$heading])), $XLSrow, $XLScol++, 0x0, $L).$row[$heading]; 
                } 
            } 
        } 
        echo pack("ss", 0x0A, 0x00); 
        die(); 
    } 
    return false; 
}
//if (!($cnn = mysql_connect("127.0.0.1", "asterisk", "da09c7c9"))) die("Not connected !!!");
//mysql_select_db("asteriskcdr");

$db = new SQLite3('/var/log/asterisk/master.db');


$dal = str_replace("/", ".", (!isset($dal))?$_REQUEST["dal"]:$dal);
$al  = str_replace("/", ".", (!isset($al))?$_REQUEST["al"]:$al);
$src = (!isset($src))?$_REQUEST["src"]:$src;
$dst = (!isset($dst))?$_REQUEST["dst"]:$dst;
$dsp = (!isset($dsp))?$_REQUEST["dsp"]:$dsp;
// $eur = (!isset($eur))?$_REQUEST["eur"]:$eur;
// if ($eur == "") $eur = 1;
// if (strpos($eur, ",") > 0) $eur = str_replace(",", ".", $eur);
// setlocale(LC_MONETARY, 'it_IT');
// $eur = money_format('%.2n', $eur);

$qdal = substr($dal, 6, 4)."-".substr($dal, 3, 2)."-".substr($dal, 0, 2)." 00:00:00";// substr($dal, 6, 4).substr($dal, 3, 2).substr($dal, 0, 2);// date("Ymd", strtotime($dal));
$qal  = substr($al, 6, 4)."-".substr($al, 3, 2)."-".substr($al, 0, 2)." 23:59:59";// substr($al, 6, 4).substr($al, 3, 2).substr($al, 0, 2); //date("Ymd", strtotime($al));
$wc = "where dst != 's' and src != 's' ";
if ($dal != "" && $al != "") $wc .= "and calldate between '$qdal' and '$qal' ";
if ($src != "") $wc .= "and src like '$src%' ";
if ($dst != "") $wc .= "and dst like '$dst%' ";
if ($dsp != "") $wc .= "and disposition = '$dsp' ";
$sql = "select calldate as Data, src as Sorgente, dst as Destinazione, duration as Durata, disposition as Stato from cdr $wc order by calldate";


$fname = "CDR Asterisk Frank- [";
if ($dal != "" && $al != "") $fname .= "$dal-$al, ";	
if ($src!="") $fname .= "Src $src, ";
if ($dst!="") $fname .= "Dst $dst, ";
if ($dsp!="") $fname .= "Stt $dsp";
$fname .= "].xls";
XLSOutput($sql, $fname);
?>

